#include "stdafx.h"

#ifndef CRYSTAL_SYS_INFO

#include "CrystalMark.h"
#include "CrystalMarkDlg.h"
#include "Bench.h"
#include "../CrystalMarkShare/Share.h"

#include <winioctl.h>

extern BOOL FlagExit;

void ExecBenchMark(void* Status)
{

	CString cstr;
	int i,j,k;
	int Data;
	void* ExData;
	_HDDInput HDDInput;
	FlagExit = FALSE;
	CString Drive,Dir,DriveSize;

	CMarkDlg* Dlg = (CMarkDlg*)Status;

	Dlg->m_FlagEntry = FALSE;

// x`ɕύXƍ鍀ڂ𖳌
	Dlg->m_MarkOptionHDDSelect.EnableWindow(FALSE);
	Dlg->m_MarkOptionHDDSize.EnableWindow(FALSE);
	SYSTEM_INFO sysInfo;
	GetSystemInfo(&sysInfo);
	// 4 vZbT܂őΉ
	if( sysInfo.dwNumberOfProcessors == 1 || sysInfo.dwNumberOfProcessors > 4 )
	{
		Dlg->m_MarkOptionProcessorMask.EnableWindow(FALSE);
	}
	if( Dlg->m_Flag[0] != TRUE ){
		Dlg->BenchSetting.DiskSize=0;
		Dlg->BenchSetting.ProcessorMask="";
		Dlg->BenchSetting.DisplayMode="";
		Dlg->BenchSetting.FontSmoothing="";
		Dlg->BenchSetting.DISP1=0;
		Dlg->BenchSetting.DISP2=0;
		Dlg->BenchSetting.DISP3=0;
		Dlg->BenchSetting.DISP4=0;
		Dlg->m_FlagEntry=FALSE;
		for(int i=0;i<=10;i++){
			Dlg->m_Mater[i]->SetFontColor(RGB(128,128,128),RGB(128,128,128),RGB(128,128,128),RGB(64,64,64));\
			Dlg->m_Mater[i]->SetMaterColor(RGB(240,240,240));
		}
	}
	
// HDD ̗eʃ`FbNeXgpf[^p
	if( Dlg->m_Flag[0] || Dlg->m_Flag[4] ){
		Dlg->m_MarkOptionHDDSelect.GetWindowText(Drive);
		Drive = Drive[0] + '\0';Drive += ":\\";
		Dir.Format("%sCrystalMark%08X",Drive,GetTickCount());
		CreateDirectory(Dir,NULL);
		wsprintf(HDDInput.FileName,"%s\\CrystalMark%08X.tmp",Dir,GetTickCount());
		Dlg->m_MarkOptionHDDSize.GetWindowText(DriveSize);
		HDDInput.HDDSize = 1024 * 1024 * atoi(DriveSize);
		HDDInput.BufSize = 1024 * 1024;
		Dlg->BenchSetting.DiskSize = atoi(DriveSize);
		ExData = (void*)&HDDInput;
	}else{
		ExData = (void*)&Data;
	}

	Dlg->m_MarkSubDlg->m_MarkSubList.DeleteAllItems();

// ʔz񁕃[^̏
	for(i=0;i<=10;i++){
		if(Dlg->m_Flag[0] || Dlg->m_Flag[i]){
			Dlg->R[0][i] = 0;
			for(int j=0;j<16;j++){
				Dlg->R[i][j] = 0;
				Dlg->V[i][j] = 0;
			}
			Dlg->m_Mater[i]->SetWidth(Dlg->R[0][i]);
		}
	}

	// vXRA
	Dlg->R[0][0] = 0;
	for(i=1;i<=10;i++){
		Dlg->R[0][0] += Dlg->R[0][i];
	}
	Dlg->m_Mater[0]->SetWidth(Dlg->R[0][0]);

// x`}[N
	for(i=1;i<=7;i++){
		if(Dlg->m_Flag[0] || Dlg->m_Flag[i]){
			GetDisplayMode(Dlg->D[i][0],Dlg->D[i][1],Dlg->D[i][2],Dlg->D[i][3]);
			if(i>5){
				Dlg->SelectTab(i - 2);
			}else{
				Dlg->SelectTab(i - 1);
			}
			if(i != 4){// HDD ȊO //
				for(j=0;j<8;j++){
					if(FlagExit){goto END;}
					ExecBenchMarkSub(Dlg,i,j,ExData);
				}
			}else{// HDD //
				if( ConstructHddTest(&HDDInput) != TRUE ){return ;}

				/********************************
				Ƃ肠ő̒l𗘗p
				********************************/
				int MaxR,MaxV;
				for(j=0;j<8;j++){
					if(FlagExit){goto END;}
					MaxR=0;
					MaxV=0;
					for(k=0;k<3;k++){
						BenchMark(i,j,1,ExData,&(Dlg->R[i][j]),&(Dlg->V[i][j]));
						if(Dlg->R[i][j] > MaxR){MaxR = Dlg->R[i][j];}
						if(Dlg->V[i][j] > MaxV){MaxV = Dlg->V[i][j];}
						/*
						char str[256];
						wsprintf(str,"R = %d, V = %d",Dlg->R[i][j],Dlg->V[i][j]);
						MessageBox(NULL,str,str,MB_OK);
						*/
					}
					Dlg->R[i][j] = MaxR;
					Dlg->V[i][j] = MaxV;
					ExecBenchMarkSub(Dlg,i,j,ExData);
				}
			}
		}
		// SȂƃGg[\ɂȂ܂ //
		if( Dlg->m_Flag[0] == TRUE){
			Dlg->m_FlagEntry = TRUE;
		}
	}
/*
	Dlg->m_MarkSubDlg->m_MarkSubList.SetFocus();
	Dlg->m_MarkSubDlg->m_MarkSubList.SetHotItem(j);
	Dlg->m_MarkSubDlg->UpdateWindow();
*/
END:

// t@C̍폜
	if( Dlg->m_Flag[0] || Dlg->m_Flag[4] ){
		VirtualFree(HDDInput.hdd,HDDInput.BufSize,MEM_DECOMMIT);
		DeleteFile(HDDInput.FileName);
		RemoveDirectory(Dir);
	}
	
	Dlg->ChangeAllWindowStatus(TRUE);
	Dlg->CalcAllScore();
	if(Dlg->m_Flag[0] == TRUE){
		Dlg->SelectTab(0);
	}
	if(FlagExit){
		Dlg->BenchSetting.DiskSize=0;
		Dlg->BenchSetting.ProcessorMask="";
		Dlg->BenchSetting.DisplayMode="";
		Dlg->BenchSetting.FontSmoothing="";
		Dlg->BenchSetting.DISP1=0;
		Dlg->BenchSetting.DISP2=0;
		Dlg->BenchSetting.DISP3=0;
		Dlg->BenchSetting.DISP4=0;
		Dlg->m_FlagEntry=FALSE;
		for(int i=0;i<=10;i++){
			Dlg->m_Mater[i]->SetFontColor(RGB(128,128,128),RGB(128,128,128),RGB(128,128,128),RGB(64,64,64));\
			Dlg->m_Mater[i]->SetMaterColor(RGB(240,240,240));
		}
	}
	for(i=0;i<=10;i++){Dlg->m_Flag[i] = FALSE;}

// x`ɕύXƍ鍀ڂL
	Dlg->m_MarkOptionHDDSelect.EnableWindow(TRUE);
	Dlg->m_MarkOptionHDDSize.EnableWindow(TRUE);
	// 4 vZbT܂őΉ
	if( sysInfo.dwNumberOfProcessors != 1 && sysInfo.dwNumberOfProcessors <= 4 )
	{
		Dlg->m_MarkOptionProcessorMask.EnableWindow(TRUE);
	}
}

void ExecBenchMarkSub(CMarkDlg* Dlg,DWORD Type,DWORD Number,void* ExData)
{
#ifndef CRYSTAL_SYS_INFO
	// }`Xbhǂ͖ //
	CWaitCursor wait;
	Sleep(50);
	CString cstr1,cstr2,unit;

	if(Type != 4){ // HDD ȊO 
		if( BenchMark(Type,Number,1,ExData,&(Dlg->R[Type][Number]),&(Dlg->V[Type][Number])) ){
			// G[ 
			FlagExit = TRUE;
		}
	}

	if(Dlg->R[Type][Number] >= 0){
		switch (Type)
		{
		case 3:// MEM
		case 4:// HDD
		case 7:// D2D
		case 8:// D3D
		case 9:// OGL
			cstr1.Format("%.2f",Dlg->V[Type][Number] / 100.0);
			cstr2.Format("%d",Dlg->R[Type][Number]);
			break;
		default:
			cstr1.Format("%d",Dlg->V[Type][Number]);
			cstr2 = "";
			break;
		}
	}

	Dlg->m_MarkSubDlg->m_MarkSubList.SetItemText(Number,1,cstr1);
	if( Type == 3 || Type == 4 || Type == 7 || Type == 8 || Type == 9 ){
		Dlg->m_MarkSubDlg->m_MarkSubList.SetItemText(Number,2,cstr2);
	}

// XRA //
	Dlg->R[0][Type] = 0;
	for(int i=0;i<16;i++){
		Dlg->R[0][Type] += Dlg->R[Type][i];
	}
	Dlg->m_Mater[Type]->SetWidth(Dlg->R[0][Type]);

	Dlg->R[0][0] = 0;
	for(int j=1;j<=10;j++){
		Dlg->R[0][0] += Dlg->R[0][j];
	}
	Dlg->m_Mater[0]->SetWidth(Dlg->R[0][0]);

#endif
}


int ConstructHddTest(_HDDInput* HDDInput)
{
	BOOL FlagArc;
// hCük擾
	char RootPath[4];
	memcpy(RootPath,HDDInput->FileName,3);RootPath[3] = '\0';
	DWORD FileSystemFlags;
	GetVolumeInformation(RootPath,NULL,NULL,NULL,NULL,&FileSystemFlags,NULL,NULL);
	if( FileSystemFlags & FS_VOL_IS_COMPRESSED ){
		FlagArc = TRUE;
	}else{
		FlagArc = FALSE;
	}

// hCű󂫗eʂmF //
	OSVERSIONINFO osVersionInfo;
	osVersionInfo.dwOSVersionInfoSize=sizeof(OSVERSIONINFO);
	GetVersionEx(&osVersionInfo);
	// Windows95 hm[} 
	if(osVersionInfo.dwPlatformId == VER_PLATFORM_WIN32_WINDOWS && LOWORD(osVersionInfo.dwBuildNumber) < 1000){
		DWORD SectorsPerCluster,BytesPerSectors,NumberOfFreeClusters,TotalNumberOfClusters;
		GetDiskFreeSpace(RootPath,&SectorsPerCluster,&BytesPerSectors,&NumberOfFreeClusters,&TotalNumberOfClusters);
		DWORD dwFreeSpace = SectorsPerCluster * BytesPerSectors * NumberOfFreeClusters;
		if( HDDInput->HDDSize * 1024 > dwFreeSpace){
			AfxMessageBox("HDD eʂsĂ邽߃x`}[Ns܂");
			return FALSE;
		}
	}else{	// Windows95 ̏^ȊO GetDiskFreeSpaceEx g
		BOOL (WINAPI *GetDiskFreeSpaceEX)(LPCTSTR,PULARGE_INTEGER,PULARGE_INTEGER,PULARGE_INTEGER);
		ULARGE_INTEGER FreeBytesAvailableToCaller,TotalNumberOfBytes,TotalNumberOfFreeBytes;
		GetDiskFreeSpaceEX = (BOOL (WINAPI *)(LPCTSTR,PULARGE_INTEGER,PULARGE_INTEGER,PULARGE_INTEGER) )GetProcAddress(GetModuleHandle("kernel32.dll"),"GetDiskFreeSpaceExA");
		GetDiskFreeSpaceEX(RootPath,&FreeBytesAvailableToCaller,&TotalNumberOfBytes,&TotalNumberOfFreeBytes);
		if(TotalNumberOfFreeBytes.HighPart == 0 && HDDInput->HDDSize * 1024 > TotalNumberOfFreeBytes.LowPart ){
			AfxMessageBox("HDD eʂsĂ邽߃x`}[Ns܂");
			return FALSE;
		}
	}
// ݉\`FbN
	
	DWORD writesize;
	char data[] = "";
	HANDLE hFile = ::CreateFile(HDDInput->FileName,GENERIC_READ|GENERIC_WRITE,0,NULL,CREATE_ALWAYS,
		FILE_ATTRIBUTE_NORMAL,NULL);

	WriteFile(hFile,data,1,&writesize,NULL);
	CloseHandle(hFile);
	DeleteFile(HDDInput->FileName);
	if(writesize == 0){
		AfxMessageBox("݂łȂhCû悤łB݉\ȃhCuIĂ");
		return FALSE;
	}

// t@Cp
	DWORD HDDSize = HDDInput->HDDSize;
	DWORD BufSize = HDDInput->BufSize;
	DWORD Loop = HDDSize / BufSize;
	DWORD i;
	DWORD ScoreMax = 0,Score = 0;
	CString RV,cstr;

	char* hdd = (char*)VirtualAlloc(NULL,BufSize,MEM_COMMIT,PAGE_READWRITE);
	HDDInput->hdd = hdd;

	if(FlagArc != FALSE){ // khCȕꍇ
		DWORD temp = BufSize / 2;
		for(i=0;i<temp;i++){memset((USHORT*)&HDDInput->hdd[i*2],rand(),2);}
	}

	hFile = ::CreateFile(HDDInput->FileName,GENERIC_READ|GENERIC_WRITE,0,NULL,CREATE_ALWAYS,
		FILE_ATTRIBUTE_NORMAL|FILE_FLAG_NO_BUFFERING|FILE_FLAG_SEQUENTIAL_SCAN,NULL);

// k //
	USHORT lpInBuffer = COMPRESSION_FORMAT_NONE;
	DWORD lpBytesReturned = 0;
	DeviceIoControl(hFile,FSCTL_SET_COMPRESSION,(LPVOID) &lpInBuffer,sizeof(USHORT),NULL,0,(LPDWORD) &lpBytesReturned,NULL);

	for(i=0;i<Loop;i++){WriteFile(hFile,hdd,BufSize,&writesize,NULL);}
	CloseHandle(hFile);

	return TRUE;
}

#endif // #ifndef CRYSTAL_SYS_INFO

