#include "stdafx.h"

#ifndef CRYSTAL_SYS_INFO

#include "crystalmark.h"
#include "CrystalMarkDlg.h"
#include "MarkDlg.h"
#include "MarkOptionDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMarkOptionDlg _CAO


CMarkOptionDlg::CMarkOptionDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMarkOptionDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMarkOptionDlg)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
	//}}AFX_DATA_INIT
}


void CMarkOptionDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMarkOptionDlg)
	DDX_Control(pDX, IDC_MARK_OPTION_HDD_SIZE, m_MarkOptionHDDSize);
	DDX_Control(pDX, IDC_MARK_OPTION_PROCESSOR_MASK, m_MarkOptionProcessorMask);
	DDX_Control(pDX, IDC_MARK_OPTION_HDD_SELECT, m_MarkOptionHDDSelect);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CMarkOptionDlg, CDialog)
	//{{AFX_MSG_MAP(CMarkOptionDlg)
//	ON_WM_CTLCOLOR()
	ON_CBN_SELCHANGE(IDC_MARK_OPTION_PROCESSOR_MASK, OnSelchangeMarkOptionProcessorMask)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMarkOptionDlg bZ[W nh

void CMarkOptionDlg::OnCancel() 
{
//	CDialog::OnCancel();
}

void CMarkOptionDlg::OnOK() 
{
//	CDialog::OnOK();
}

BOOL CMarkOptionDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	// Processor Mask ̐ݒ
	CString cstr;
	SYSTEM_INFO sysInfo;
	GetSystemInfo(&sysInfo);

	// 4 vZbT܂őΉ
	if( sysInfo.dwNumberOfProcessors == 1 || sysInfo.dwNumberOfProcessors > 4 )
	{
		m_MarkOptionProcessorMask.EnableWindow(FALSE);
	}
		
	if( sysInfo.dwNumberOfProcessors >= 1 ){
		m_MarkOptionProcessorMask.AddString("0001");
	}
	if( sysInfo.dwNumberOfProcessors >= 2 ){
		m_MarkOptionProcessorMask.AddString("0011");
	}
	if( sysInfo.dwNumberOfProcessors >= 3 ){
		m_MarkOptionProcessorMask.AddString("0111");
	}
	if( sysInfo.dwNumberOfProcessors >= 4 ){
		m_MarkOptionProcessorMask.AddString("0101");
		m_MarkOptionProcessorMask.AddString("1111");
	}
	m_MarkOptionProcessorMask.SetCurSel( m_MarkOptionProcessorMask.GetCount() - 1 );

	m_MarkOptionHDDSize.AddString("128MB");
	m_MarkOptionHDDSize.AddString("256MB");
	m_MarkOptionHDDSize.AddString("512MB");
	m_MarkOptionHDDSize.AddString("1024MB");
	m_MarkOptionHDDSize.SetCurSel(0);
	m_MarkOptionHDDSize.UpdateWindow();

	Internationalise();
	// TODO: ̈ʒuɏ̕⑫ǉĂ
	
	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

void CMarkOptionDlg::Internationalise()
{
	// LȃhCuXgAbv
	CString cstr;
	char  szDrives[128];
	char* pDrive;
	GetLogicalDriveStrings( sizeof(szDrives), szDrives );
	pDrive = szDrives;
	m_MarkOptionHDDSelect.ResetContent();
	while( *pDrive )
	{
		int result = GetDriveType(pDrive);
		if(result != DRIVE_FIXED && result != DRIVE_REMOTE
		|| (result == DRIVE_REMOVABLE  && ( pDrive[0] != 'A' || pDrive[0] != 'B' ) ))
		{
			pDrive += strlen( pDrive ) + 1;
			continue;
		}
		int forward = strlen( pDrive );
		pDrive[1] = '\0';
		_strupr(pDrive);// 啶ɕϊ
		cstr = pDrive;
		if(result == DRIVE_FIXED){
			if( gLanguage == JAPANESE ){
				cstr += " : n[hfBXN";
			}else{
				cstr += " : HardDisk";
			}
			char RootPath[4];
			char FileSystem[32];
			RootPath[0] = pDrive[0];RootPath[1] = ':';RootPath[2] = '\\';RootPath[3] = '\0';
			GetVolumeInformation(RootPath,NULL,NULL,NULL,NULL,NULL,FileSystem,sizeof(FileSystem));
			cstr += " ["; cstr += FileSystem; cstr += "]";
			m_MarkOptionHDDSelect.AddString(cstr);
		}
//		else if(result == DRIVE_REMOTE){cstr += " : lbg[N";}
//		else if(result == DRIVE_REMOVABLE){cstr += " : [ou";}
//		else{cstr += " : s";}
		pDrive += forward + 1;
	}

	m_MarkOptionHDDSelect.SetCurSel(0);
	m_MarkOptionHDDSelect.UpdateWindow();
}

static BOOL IsWinNT()
{
	OSVERSIONINFO OSVersionInfo;
	OSVersionInfo.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
	GetVersionEx(&OSVersionInfo);
	
	return OSVersionInfo.dwPlatformId == VER_PLATFORM_WIN32_NT;
}

typedef int(WINAPI * _SetProcessAffinityMask_)(void*, DWORD);

void CMarkOptionDlg::OnSelchangeMarkOptionProcessorMask() 
{
	CString cstr;
	m_MarkOptionProcessorMask.GetWindowText(cstr);

	DWORD mask;
	if(cstr == "0001"){mask = 0x1;}
	if(cstr == "0011"){mask = 0x3;}
	if(cstr == "0101"){mask = 0x5;}
	if(cstr == "0111"){mask = 0x7;}
	if(cstr == "1111"){mask = 0xF;}

	if( IsWinNT() ){
		_SetProcessAffinityMask_ SetProcessAffinityMask = NULL;
		SetProcessAffinityMask = (_SetProcessAffinityMask_) GetProcAddress (GetModuleHandle("kernel32"),"SetProcessAffinityMask");

		if( SetProcessAffinityMask != NULL ){
			mask = SetProcessAffinityMask(GetCurrentProcess(),mask);
		//	cstr.Format("%X",mask);MessageBox(cstr);
		}
	}
}

#endif // #ifndef CRYSTAL_SYS_INFO
