#if !defined(AFX_MARKDLG_H__5C4A8F56_5E30_4E7E_A2A0_C62817078B1E__INCLUDED_)
#define AFX_MARKDLG_H__5C4A8F56_5E30_4E7E_A2A0_C62817078B1E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// MarkDlg.h : wb_[ t@C
//
#include "MarkSubDlg.h"
#include "MarkOptionDlg.h"

#include "CrystalMater.h"

struct _BenchSetting
{
	CString ProcessorMask;
	CString DisplayMode;
	CString FontSmoothing;
	int DiskSize;
	int DISP1;
	int DISP2;
	int DISP3;
	int DISP4;
};

/////////////////////////////////////////////////////////////////////////////
// CMarkDlg _CAO

class CMarkDlg : public CDialog
{
// RXgNV
public:
	void ChangeAllWindowStatus(BOOL flag,BOOL type = TRUE);
	void SelectTab(int Tab);
	void CalcAllScore();
	void MarkStart(DWORD ID);
	BOOL IsEntryOK();
	CMarkDlg(CWnd* pParent = NULL);   // W̃RXgN^
	CMarkSubDlg* m_MarkSubDlg;
#ifdef USE_OPTION
	CMarkOptionDlg* m_MarkOptionDlg;
#endif
	~CMarkDlg();
	BOOL m_FlagEntry;
	HANDLE m_hThread;
	int D[11][4];// Display Mode 0:width 1:height 2:color 3:font  
	int R[11][16];
	int V[11][16];
	BOOL m_Flag[11];
	CCrystalMater* m_Mater[11];
	void Internationalise();
	_BenchSetting BenchSetting;
// _CAO f[^
	//{{AFX_DATA(CMarkDlg)
	enum { IDD = IDD_MARK_DIALOG };
	CEdit	m_MarkOptionFontSmoothingC;
	CEdit	m_MarkOptionDisplayModeC;
	CComboBox	m_MarkOptionProcessorMask;
	CComboBox	m_MarkOptionHDDSize;
	CComboBox	m_MarkOptionHDDSelect;
	CCrystalMater	m_MarkOGLScoreC;
	CButton	m_MarkOGLC;
	CCrystalMater	m_MarkMEMScoreC;
	CCrystalMater	m_MarkNETScoreC;
	CCrystalMater	m_MarkMMTScoreC;
	CCrystalMater	m_MarkMarkScoreC;
	CCrystalMater	m_MarkHDDScoreC;
	CCrystalMater	m_MarkGDIScoreC;
	CCrystalMater	m_MarkFPUScoreC;
	CCrystalMater	m_MarkD3DScoreC;
	CCrystalMater	m_MarkD2DScoreC;
	CCrystalMater	m_MarkALUScoreC;
	CButton	m_MarkStopC;
	CButton	m_MarkNETC;
	CButton	m_MarkMMTC;
	CButton	m_MarkMEMC;
	CButton	m_MarkMarkC;
	CButton	m_MarkHDDC;
	CButton	m_MarkGDIC;
	CButton	m_MarkFPUC;
	CButton	m_MarkD3DC;
	CButton	m_MarkD2DC;
	CButton	m_MarkALUC;
	CTabCtrl	m_MarkTab;
	CString	m_MarkOptionFontSmoothing;
	CString	m_MarkOptionDisplayMode;
	//}}AFX_DATA


// I[o[Ch
	// ClassWizard ͉z֐̃I[o[Ch𐶐܂B
	//{{AFX_VIRTUAL(CMarkDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV T|[g
	//}}AFX_VIRTUAL

// Cve[V
protected:
	void AddPage(CDialog* pDlg,UINT id);
	// ꂽbZ[W }bv֐
	//{{AFX_MSG(CMarkDlg)
	virtual void OnOK();
	virtual void OnCancel();
	virtual BOOL OnInitDialog();
	afx_msg void OnMarkAlu();
	afx_msg void OnSelchangeMarkTab(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnMarkMark();
	afx_msg void OnMarkStop();
	afx_msg void OnMarkFpu();
	afx_msg void OnMarkMem();
	afx_msg void OnMarkHdd();
	afx_msg void OnMarkGdi();
	afx_msg void OnMarkMmt();
	afx_msg void OnMarkD2d();
	afx_msg void OnMarkD3d();
	afx_msg void OnMarkNet();
	afx_msg HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
	afx_msg void OnMarkOgl();
	afx_msg void OnSelchangeMarkOptionProcessorMask();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ ͑Os̒Oɒǉ̐錾}܂B

#endif // !defined(AFX_MARKDLG_H__5C4A8F56_5E30_4E7E_A2A0_C62817078B1E__INCLUDED_)
