#include "stdafx.h"

#ifndef CRYSTAL_SYS_INFO

#include "CrystalMark.h"
#include "CrystalMarkDlg.h"
#include "RankingDlg.h"
#include "ResultDlg.h"
#include "../CrystalMarkShare/Share.h"
#include "../CrystalMarkDll/CrystalMarkDll.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define USER_AGENT "CrystalMark08"

#ifdef _DEBUG
#define SERVER_NAME "localhost"
#define SCRIPT_PATH "/~hiyohiyo/CrystalMark/08/regist.php"
#define RANKING_STR	"http://localhost/CrystalMark/08/ranking.php?ID=%d"
#endif 
/**/

#ifndef _DEBUG
#define SERVER_NAME "musee.cims.hokudai.ac.jp"
#define SCRIPT_PATH "/~hiyohiyo/CrystalMark/08/regist.php"
#define RANKING_STR	"http://musee.cims.hokudai.ac.jp/~hiyohiyo/CrystalMark/08/ranking.php?ID=%d"
#endif

static CCrystalMarkDlg* Dlg;

/////////////////////////////////////////////////////////////////////////////
// CRankingDlg _CAO

CRankingDlg::CRankingDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CRankingDlg::IDD, pParent)
{
	Dlg = (CCrystalMarkDlg*)pParent;
	//{{AFX_DATA_INIT(CRankingDlg)
	m_ClockOriUser = _T("");
	m_ClockUser = _T("");
	m_DataRateUser = _T("");
	m_DiskNameUser = _T("");
	m_DiskSizeUser = _T("");
	m_MachineName = _T("");
	m_Mail = _T("");
	m_MemorySizeUser = _T("");
	m_MemoryUser = _T("");
	m_MotherBoardUser = _T("");
	m_MultiplierOriUser = _T("");
	m_MultiplierUser = _T("");
	m_OverClockUser = _T("");
	m_Password = _T("");
	m_SystemClockOriUser = _T("");
	m_SystemClockUser = _T("");
	m_UserName = _T("");
	m_VideoNameUser = _T("");
	m_VideoSizeUser = _T("");
	m_Web = _T("");
	m_Area = _T("");
	m_CPUNameUser = _T("");
	m_ChipSetNameUser = _T("");
	m_RaidDisk1 = _T("");
	m_RaidDisk1Size = _T("");
	m_RaidDisk2 = _T("");
	m_RaidDisk2Size = _T("");
	m_RaidDisk3 = _T("");
	m_RaidDisk4 = _T("");
	m_RaidDisk4Size = _T("");
	m_RaidSize = _T("");
	m_RaidDisk3Size = _T("");
	m_RaidType = _T("");
	m_Comment = _T("");
	m_RaidController = _T("");
	m_CountryArea = _T("");
	m_StaticHdd = _T("");
	m_StaticRaid = _T("");
	//}}AFX_DATA_INIT
}

CRankingDlg::~CRankingDlg()
{
	if( m_pFont != NULL){delete m_pFont;}
}


void CRankingDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRankingDlg)
	DDX_Control(pDX, IDC_RANK_CPU_NAME_USER, m_CPUNameUserC);
	DDX_Control(pDX, IDC_RANK_ENTRY, m_EntryC);
	DDX_Control(pDX, IDC_RANK_COUNTRY_AREA, m_CountryAreaC);
	DDX_Control(pDX, IDC_RANK_RAID_DISK3_SHADOW, m_RaidDisk3ShadowC);
	DDX_Control(pDX, IDC_RANK_RAID_DISK4_SHADOW, m_RaidDisk4ShadowC);
	DDX_Control(pDX, IDC_RANK_RAID_DISK2_SHADOW, m_RaidDisk2ShadowC);
	DDX_Control(pDX, IDC_RANK_RAID_DISK1_SHADOW, m_RaidDisk1ShadowC);
	DDX_Control(pDX, IDC_RANK_RAID_CONTROLLER_SHADOW, m_RaidControllerShadowC);
	DDX_Control(pDX, IDC_RANK_DISK_NAME_USER_SHADOW, m_DiskNameUserShadowC);
	DDX_Control(pDX, IDC_RANK_RAID_TYPE_SHADOWN, m_RaidTypeShadowC);
	DDX_Control(pDX, IDC_RANK_DISK_SIZE_USER, m_DiskSizeUserC);
	DDX_Control(pDX, IDC_RANK_RAID_TYPE, m_RaidTypeC);
	DDX_Control(pDX, IDC_RANK_RAID_DISK3_SIZE, m_RaidDisk3SizeC);
	DDX_Control(pDX, IDC_RANK_RAID_SIZE, m_RaidSizeC);
	DDX_Control(pDX, IDC_RANK_RAID_DISK4_SIZE, m_RaidDisk4SizeC);
	DDX_Control(pDX, IDC_RANK_RAID_DISK4, m_RaidDisk4C);
	DDX_Control(pDX, IDC_RANK_RAID_DISK3, m_RaidDisk3C);
	DDX_Control(pDX, IDC_RANK_RAID_DISK2_SIZE, m_RaidDisk2SizeC);
	DDX_Control(pDX, IDC_RANK_RAID_DISK2, m_RaidDisk2C);
	DDX_Control(pDX, IDC_RANK_RAID_DISK1_SIZE, m_RaidDisk1SizeC);
	DDX_Control(pDX, IDC_RANK_RAID_DISK1, m_RaidDisk1C);
	DDX_Control(pDX, IDC_RANK_RAID_CONTROLLER, m_RaidControllerC);
	DDX_Control(pDX, IDC_RANK_RESULT, m_RankResultList);
	DDX_Control(pDX, IDC_RANK_DISK_NAME_USER, m_DiskNameUserC);
	DDX_Control(pDX, IDC_RANK_MEMORY_SIZE_USER, m_MemorySizeUserC);
	DDX_Control(pDX, IDC_RANK_VIDEO_SIZE_USER, m_VideoSizeUserC);
	DDX_Control(pDX, IDC_RANK_VIDEO_NAME_USER, m_VideoNameUserC);
	DDX_Control(pDX, IDC_RANK_CHIP_SET_NAME_USER, m_ChipSetNameUserC);
	DDX_Control(pDX, IDC_RANK_MEMORY_USER, m_MemoryUserC);
	DDX_Control(pDX, IDC_RANK_AREA, m_AreaC);
	DDX_Control(pDX, IDC_RANK_FIX, m_Fix);
	DDX_Control(pDX, IDC_RANK_SYSTEM_CLOCK_USER, m_SystemClockUserC);
	DDX_Control(pDX, IDC_RANK_SYSTEM_CLOCK_ORI_USER, m_SystemClockOriUserC);
	DDX_Control(pDX, IDC_RANK_OVER_CLOCK_USER, m_OverClockUserC);
	DDX_Control(pDX, IDC_RANK_MULTIPLIER_USER, m_MultiplierUserC);
	DDX_Control(pDX, IDC_RANK_MULTIPLIER_ORI_USER, m_MultiplierOriUserC);
	DDX_Control(pDX, IDC_RANK_CLOCK_USER, m_ClockUserC);
	DDX_Control(pDX, IDC_RANK_CLOCK_ORI_USER, m_ClockOriUserC);
	DDX_Text(pDX, IDC_RANK_CLOCK_ORI_USER, m_ClockOriUser);
	DDV_MaxChars(pDX, m_ClockOriUser, 16);
	DDX_Text(pDX, IDC_RANK_CLOCK_USER, m_ClockUser);
	DDV_MaxChars(pDX, m_ClockUser, 128);
	DDX_Text(pDX, IDC_RANK_DATA_RATE_USER, m_DataRateUser);
	DDX_CBString(pDX, IDC_RANK_DISK_NAME_USER, m_DiskNameUser);
	DDV_MaxChars(pDX, m_DiskNameUser, 128);
	DDX_Text(pDX, IDC_RANK_DISK_SIZE_USER, m_DiskSizeUser);
	DDV_MaxChars(pDX, m_DiskSizeUser, 16);
	DDX_Text(pDX, IDC_RANK_MACHINE_NAME, m_MachineName);
	DDV_MaxChars(pDX, m_MachineName, 128);
	DDX_Text(pDX, IDC_RANK_MAIL, m_Mail);
	DDV_MaxChars(pDX, m_Mail, 256);
	DDX_Text(pDX, IDC_RANK_MEMORY_SIZE_USER, m_MemorySizeUser);
	DDV_MaxChars(pDX, m_MemorySizeUser, 16);
	DDX_CBString(pDX, IDC_RANK_MEMORY_USER, m_MemoryUser);
	DDV_MaxChars(pDX, m_MemoryUser, 128);
	DDX_Text(pDX, IDC_RANK_MOTHER_BOARD_USER, m_MotherBoardUser);
	DDV_MaxChars(pDX, m_MotherBoardUser, 128);
	DDX_Text(pDX, IDC_RANK_MULTIPLIER_ORI_USER, m_MultiplierOriUser);
	DDV_MaxChars(pDX, m_MultiplierOriUser, 16);
	DDX_Text(pDX, IDC_RANK_MULTIPLIER_USER, m_MultiplierUser);
	DDV_MaxChars(pDX, m_MultiplierUser, 16);
	DDX_Text(pDX, IDC_RANK_OVER_CLOCK_USER, m_OverClockUser);
	DDV_MaxChars(pDX, m_OverClockUser, 16);
	DDX_Text(pDX, IDC_RANK_PASSWORD, m_Password);
	DDV_MaxChars(pDX, m_Password, 16);
	DDX_Text(pDX, IDC_RANK_SYSTEM_CLOCK_ORI_USER, m_SystemClockOriUser);
	DDV_MaxChars(pDX, m_SystemClockOriUser, 16);
	DDX_Text(pDX, IDC_RANK_SYSTEM_CLOCK_USER, m_SystemClockUser);
	DDV_MaxChars(pDX, m_SystemClockUser, 16);
	DDX_Text(pDX, IDC_RANK_USER_NAME, m_UserName);
	DDV_MaxChars(pDX, m_UserName, 32);
	DDX_CBString(pDX, IDC_RANK_VIDEO_NAME_USER, m_VideoNameUser);
	DDV_MaxChars(pDX, m_VideoNameUser, 128);
	DDX_Text(pDX, IDC_RANK_VIDEO_SIZE_USER, m_VideoSizeUser);
	DDV_MaxChars(pDX, m_VideoSizeUser, 16);
	DDX_Text(pDX, IDC_RANK_WEB, m_Web);
	DDV_MaxChars(pDX, m_Web, 256);
	DDX_CBString(pDX, IDC_RANK_AREA, m_Area);
	DDV_MaxChars(pDX, m_Area, 128);
	DDX_CBString(pDX, IDC_RANK_CPU_NAME_USER, m_CPUNameUser);
	DDV_MaxChars(pDX, m_CPUNameUser, 128);
	DDX_CBString(pDX, IDC_RANK_CHIP_SET_NAME_USER, m_ChipSetNameUser);
	DDV_MaxChars(pDX, m_ChipSetNameUser, 128);
	DDX_CBString(pDX, IDC_RANK_RAID_DISK1, m_RaidDisk1);
	DDV_MaxChars(pDX, m_RaidDisk1, 128);
	DDX_Text(pDX, IDC_RANK_RAID_DISK1_SIZE, m_RaidDisk1Size);
	DDV_MaxChars(pDX, m_RaidDisk1Size, 16);
	DDX_CBString(pDX, IDC_RANK_RAID_DISK2, m_RaidDisk2);
	DDV_MaxChars(pDX, m_RaidDisk2, 128);
	DDX_Text(pDX, IDC_RANK_RAID_DISK2_SIZE, m_RaidDisk2Size);
	DDV_MaxChars(pDX, m_RaidDisk2Size, 16);
	DDX_CBString(pDX, IDC_RANK_RAID_DISK3, m_RaidDisk3);
	DDV_MaxChars(pDX, m_RaidDisk3, 128);
	DDX_CBString(pDX, IDC_RANK_RAID_DISK4, m_RaidDisk4);
	DDV_MaxChars(pDX, m_RaidDisk4, 128);
	DDX_Text(pDX, IDC_RANK_RAID_DISK4_SIZE, m_RaidDisk4Size);
	DDV_MaxChars(pDX, m_RaidDisk4Size, 16);
	DDX_Text(pDX, IDC_RANK_RAID_SIZE, m_RaidSize);
	DDV_MaxChars(pDX, m_RaidSize, 16);
	DDX_Text(pDX, IDC_RANK_RAID_DISK3_SIZE, m_RaidDisk3Size);
	DDV_MaxChars(pDX, m_RaidDisk3Size, 16);
	DDX_CBString(pDX, IDC_RANK_RAID_TYPE, m_RaidType);
	DDV_MaxChars(pDX, m_RaidType, 128);
	DDX_Text(pDX, IDC_RANK_COMMENT, m_Comment);
	DDV_MaxChars(pDX, m_Comment, 1024);
	DDX_CBString(pDX, IDC_RANK_RAID_CONTROLLER, m_RaidController);
	DDV_MaxChars(pDX, m_RaidController, 128);
	DDX_Text(pDX, IDC_RANK_COUNTRY_AREA, m_CountryArea);
	DDX_Text(pDX, IDC_STATIC_HDD, m_StaticHdd);
	DDX_Text(pDX, IDC_STATIC_RAID, m_StaticRaid);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CRankingDlg, CDialog)
	//{{AFX_MSG_MAP(CRankingDlg)
	ON_WM_CTLCOLOR()
	ON_BN_CLICKED(IDC_RANK_ENTRY, OnRankEntry)
	ON_EN_CHANGE(IDC_RANK_MULTIPLIER_ORI_USER, OnChangeRankMultiplierOriUser)
	ON_EN_CHANGE(IDC_RANK_MULTIPLIER_USER, OnChangeRankMultiplierUser)
	ON_EN_CHANGE(IDC_RANK_SYSTEM_CLOCK_ORI_USER, OnChangeRankSystemClockOriUser)
	ON_BN_CLICKED(IDC_RANK_FIX, OnRankFix)
	ON_BN_CLICKED(IDC_RANK_RAID, OnRankRaid)
	ON_WM_SHOWWINDOW()
	ON_BN_CLICKED(IDC_RANK_RESULT_DIALOG, OnRankResultDialog)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRankingDlg bZ[W nh

// Ranking ֘A

static void AddPostDataS(CString& post,CString label,CString m)
{
	CString cstr,temp;
	m.Replace("&","%26");
	m.Replace("+","%2B");
	m.Replace("=","%3D");

	// 󔒏
	temp = m;
	temp.TrimLeft();
	cstr.Format("%s=%s&",label,temp);
	post += cstr;
}

static void AddPostDataI(CString& post,CString label,int i)
{
	CString cstr;
	int j = i;
	if(j < 0){j = -1;}
	cstr.Format("%s=%d&",label,j);
	post += cstr;
}

static void AddPostDataI(CString& post,CString label,CString i)
{
	CString cstr;
	int j = atoi(i);
	if(j < 0){j = -1;}
	cstr.Format("%s=%d&",label,j);
	post += cstr;
}

static void AddPostDataX(CString& post,CString label,CString x)
{
	CString cstr;
	cstr = "0x" + x;
	int j = strtol(cstr,NULL,16);
	if(j <= 0){j = 0;}
	cstr.Format("%s=%d&",label,j);
	post += cstr;
}

static void AddPostDataF(CString& post,CString label,CString f)
{
	CString cstr;
	cstr.Format("%s=%.2f&",label,atof(f));
	post += cstr;
}

void CRankingDlg::OnChangeRankSystemClockOriUser() 
{
	UpdateData(TRUE);
	if(atof(m_SystemClockOriUser) > 0.0 && atof(m_MultiplierOriUser) >= 1.0){
		m_ClockOriUser.Format("%.2f",atof(m_SystemClockOriUser) * atof(m_MultiplierOriUser) );
		m_OverClockUser.Format("%.2f",atof(m_ClockUser) / atof(m_ClockOriUser) * 100.0 - 100.0);
	}
	UpdateData(FALSE);
	if( gFlagBack ){
		WindowFlash(m_ClockOriUserC);
		WindowFlash(m_OverClockUserC);
	}
}

void CRankingDlg::OnChangeRankMultiplierOriUser() 
{
	UpdateData(TRUE);
	if(atof(m_SystemClockOriUser) > 0.0 && atof(m_MultiplierOriUser) >= 1.0){
		m_ClockOriUser.Format("%.2f",atof(m_SystemClockOriUser) * atof(m_MultiplierOriUser) );
		m_OverClockUser.Format("%.2f",atof(m_ClockUser) / atof(m_ClockOriUser) * 100.0 - 100.0);
	}
	UpdateData(FALSE);
	if( gFlagBack ){
		WindowFlash(m_ClockOriUserC);
		WindowFlash(m_OverClockUserC);
	}
}

void CRankingDlg::OnChangeRankMultiplierUser() 
{
	UpdateData(TRUE);
	if(atof(m_MultiplierUser) >= 1.0 && atof(m_ClockUser) > 0.0){
		m_SystemClockUser.Format("%.2f",atof(m_ClockUser) / atof(m_MultiplierUser) );
	}
	UpdateData(FALSE);
	if( gFlagBack ){
		WindowFlash(m_ClockUserC);
		WindowFlash(m_SystemClockUserC);
		WindowFlash(m_OverClockUserC);
	}
}

void CRankingDlg::OnRankFix() 
{
	static BOOL flag = FALSE;

	m_CPUNameUserC.SetReadOnly(flag);
	m_SystemClockOriUserC.SetReadOnly(flag);
	m_MultiplierOriUserC.SetReadOnly(flag);
	m_MultiplierUserC.SetReadOnly(flag);
	if( gFlagBack ){
		WindowFlash(m_CPUNameUserC);
		WindowFlash(m_SystemClockOriUserC);
		WindowFlash(m_MultiplierOriUserC);
		WindowFlash(m_MultiplierUserC);
	}
	flag = !flag;
}

void CRankingDlg::Internationalise()
{
	UpdateData(TRUE);

	CString dir = "";
	char myapp[MAX_PATH];
	char *token;
	char *temp;
// sfBNg擾
// ɃGKgw̒ႢASYł邪[lȂƂɂB
	::GetModuleFileName(NULL,myapp,MAX_PATH);
	if(myapp[0] == '\\'){dir += "\\\\";} // lbg[NhCu΍
	token = strtok( myapp , "\\");
	while(token != NULL){
		temp = token;
		if(NULL != (token = strtok( NULL , "\\") )){
			dir += temp;dir += "\\";
		}
	}
	
	CString tmp;
	tmp = m_Area;
	CString AreaFile;
	if( gLanguage == JAPANESE ){
		AreaFile = dir + "data\\area.dat";
		m_CountryArea = "Area (*)";
	}else{
		AreaFile = dir + "data\\country.dat";
		m_CountryArea = "Country (*)";
	}
// nf[^x[X
	LoadDataBase(AreaFile,m_AreaC);
	m_Area = tmp;
	UpdateData(FALSE);
	WindowFlash(m_CountryAreaC);

}

static void ShowComboString(CComboBox& combo,CString& cstr)
{
	combo.DeleteString(0);
	combo.AddString(cstr);
	combo.SetCurSel(0);
}

void CRankingDlg::OnRankRaid() 
{
	m_RaidOn = ! m_RaidOn;

	if( m_RaidOn ){
		m_StaticHdd = "HDD";
		m_StaticRaid = "Controller (*)";
	}else{
		m_StaticHdd = "HDD (*)";
		m_StaticRaid = "Controller";
	}
	UpdateData(TRUE);

	CString cstr;
// Disk
	m_DiskNameUserC.GetWindowText(cstr);
	ShowComboString(m_DiskNameUserShadowC,cstr);
	m_DiskNameUserShadowC.ShowWindow(m_RaidOn);
	m_DiskNameUserC.ShowWindow(!m_RaidOn);

// Raid
	m_RaidTypeC.GetWindowText(cstr);
	ShowComboString(m_RaidTypeShadowC,cstr);
	m_RaidControllerC.GetWindowText(cstr);
	ShowComboString(m_RaidControllerShadowC,cstr);
	m_RaidDisk1C.GetWindowText(cstr);
	ShowComboString(m_RaidDisk1ShadowC,cstr);
	m_RaidDisk2C.GetWindowText(cstr);
	ShowComboString(m_RaidDisk2ShadowC,cstr);
	m_RaidDisk3C.GetWindowText(cstr);
	ShowComboString(m_RaidDisk3ShadowC,cstr);
	m_RaidDisk4C.GetWindowText(cstr);
	ShowComboString(m_RaidDisk4ShadowC,cstr);

// Show
	m_RaidTypeShadowC.ShowWindow(!m_RaidOn);
	m_RaidControllerShadowC.ShowWindow(!m_RaidOn);
	m_RaidDisk1ShadowC.ShowWindow(!m_RaidOn);
	m_RaidDisk2ShadowC.ShowWindow(!m_RaidOn);
	m_RaidDisk3ShadowC.ShowWindow(!m_RaidOn);
	m_RaidDisk4ShadowC.ShowWindow(!m_RaidOn);
	
	m_RaidTypeC.ShowWindow(m_RaidOn);
	m_RaidControllerC.ShowWindow(m_RaidOn);
	m_RaidDisk1C.ShowWindow(m_RaidOn);
	m_RaidDisk2C.ShowWindow(m_RaidOn);
	m_RaidDisk3C.ShowWindow(m_RaidOn);
	m_RaidDisk4C.ShowWindow(m_RaidOn);

// Enable
	m_DiskNameUserC.EnableWindow(!m_RaidOn);
	m_DiskSizeUserC.EnableWindow(!m_RaidOn);

	m_RaidDisk1C.EnableWindow(m_RaidOn);
	m_RaidDisk2C.EnableWindow(m_RaidOn);
	m_RaidDisk3C.EnableWindow(m_RaidOn);
	m_RaidDisk4C.EnableWindow(m_RaidOn);
	m_RaidDisk1SizeC.EnableWindow(m_RaidOn);
	m_RaidDisk2SizeC.EnableWindow(m_RaidOn);
	m_RaidDisk3SizeC.EnableWindow(m_RaidOn);
	m_RaidDisk4SizeC.EnableWindow(m_RaidOn);
	m_RaidControllerC.EnableWindow(m_RaidOn);
	m_RaidSizeC.EnableWindow(m_RaidOn);
	m_RaidTypeC.EnableWindow(m_RaidOn);
}

void CRankingDlg::SetCpuInfo()
{
	m_ClockUser = Dlg->m_CPUDlg->m_Clock;
	m_SystemClockUser = Dlg->m_CPUDlg->m_SystemClock;
	m_MultiplierUser = Dlg->m_CPUDlg->m_Multiplier;
	m_ClockOriUser = Dlg->m_CPUDlg->m_ClockOri;
	m_OverClockUser = Dlg->m_CPUDlg->m_OverClock;
	m_SystemClockOriUser = Dlg->m_CPUDlg->m_SystemClockOri;
	m_MultiplierOriUser = Dlg->m_CPUDlg->m_MultiplierOri;
	m_DataRateUser = Dlg->m_CPUDlg->m_DataRate;

	UpdateData(FALSE);
}

BOOL CRankingDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	m_StaticHdd = "HDD (*)";
	m_StaticRaid = "Controller";

	m_RaidOn = FALSE;

	m_pFont = new CFont;
	m_pFont->CreatePointFont( 120 ,"Arial",NULL);
	m_RankResultList.SetFont(m_pFont,TRUE);

// Xgr[̍\z
	LVCOLUMN myColumn;
	myColumn.mask = LVCF_TEXT | LVCF_WIDTH | LVCF_ORDER ;

	// Rg[̕擾
	CRect cr;m_RankResultList.GetClientRect(cr);
	DWORD width = cr.Width();// - GetSystemMetrics(SM_CXVSCROLL);

	double comctl32 = GetFileVersion("comctl32.dll");
	if( comctl32 >= 4.70 ){
		long dwStyle = ListView_GetExtendedListViewStyle(m_RankResultList.m_hWnd);
		dwStyle |=	LVS_EX_FULLROWSELECT | LVS_EX_GRIDLINES;
		ListView_SetExtendedListViewStyle(m_RankResultList.m_hWnd, dwStyle);
	}
	if( comctl32 >= 4.71 ){
		m_RankResultList.GetHeaderCtrl()->EnableWindow(FALSE);
	}
	m_RankResultList.InsertColumn(0,"Item",LVCFMT_LEFT,width * 65 / 100,0);
	m_RankResultList.InsertColumn(1,"Score",LVCFMT_RIGHT,width * 35 / 100,0);

	SetCpuInfo();

// HDD hCuXgZbgAbv
	int i = Dlg->m_DiskDlg->m_DiskList.GetItemCount();
	while(i > 0){
		i--;
		m_DiskNameUserC.InsertString(0,Dlg->m_DiskDlg->m_DiskList.GetItemText(i,0));
		m_RaidDisk1C.InsertString(0,Dlg->m_DiskDlg->m_DiskList.GetItemText(i,0));
		m_RaidDisk2C.InsertString(0,Dlg->m_DiskDlg->m_DiskList.GetItemText(i,0));
		m_RaidDisk3C.InsertString(0,Dlg->m_DiskDlg->m_DiskList.GetItemText(i,0));
		m_RaidDisk4C.InsertString(0,Dlg->m_DiskDlg->m_DiskList.GetItemText(i,0));
	}

	CString data = "";
	CString dir = "";
	char myapp[MAX_PATH];
	char str[256];
	char *token;
	char *temp;
// sfBNg擾
// ɃGKgw̒ႢASYł邪[lȂƂɂB
	::GetModuleFileName(NULL,myapp,MAX_PATH);
	if(myapp[0] == '\\'){dir += "\\\\";} // lbg[NhCu΍
	token = strtok( myapp , "\\");
	while(token != NULL){
		temp = token;
		if(NULL != (token = strtok( NULL , "\\") )){
			dir += temp;dir += "\\";
		}
	}
// t@C
	CString CPUFile = dir;
	CString vendor = Dlg->m_CPUDlg->m_VendorString;
// CPU ͎͂ŏ\ 03/05/21
/*	
	if( strcmp(vendor,"GenuineIntel") == 0){
		CPUFile += "data\\cpuintel.dat";
	}else if(strcmp(vendor,"AuthenticAMD") == 0){
		CPUFile += "data\\cpuamd.dat";
	}else{
		CPUFile += "data\\cpu.dat";
	}
*/
	CString MemoryFile = dir + "data\\memory.dat";
	CString ChipSetFile = dir + "data\\chipset.dat";
	CString VideoFile = dir + "data\\video.dat";

	Internationalise();

// f[^x[X
	LoadDataBase(MemoryFile,m_MemoryUserC);
// CPU f[^x[Xǂݍ݃R{{bNXɒǉ
//	LoadDataBase(CPUFile,m_CPUNameUserC);
//	if(m_CPUNameUserC.GetWindowTextLength() == 0){m_CPUNameUserC.SelectString(-1,str);}
// `bvZbgf[^x[X
	ChipSetList("data\\chipset.pci",m_ChipSetNameUserC);
	if(m_ChipSetNameUserC.GetWindowTextLength() == 0){m_ChipSetNameUserC.SelectString(-1,str);}
// rfI`bvf[^x[X
	DeviceNameList("data\\video.pci",m_VideoNameUserC);
	if(m_VideoNameUserC.GetWindowTextLength() == 0){m_VideoNameUserC.SelectString(-1,str);}

// I
/*
	if( Dlg->m_CPUDlg->m_CodeName.IsEmpty() ){
		m_CPUNameUser.Format("%s",Dlg->m_CPUDlg->m_CPUName);
	}else{
		m_CPUNameUser.Format("%s (%s)",Dlg->m_CPUDlg->m_CPUName,Dlg->m_CPUDlg->m_CodeName);
	}
*/
	m_CPUNameUserC.SetWindowText(Dlg->m_CPUDlg->m_CPUNameSI);

	m_ChipSetNameUser = Dlg->m_DeviceDlg->m_DeviceChipSet;
	m_ChipSetNameUser.Delete(0,1);
	m_VideoNameUser = Dlg->m_DeviceDlg->m_DeviceVideo;
	m_VideoNameUser.Delete(0,1);

	m_RaidTypeC.AddString("RAID 0");
	m_RaidTypeC.AddString("RAID 1");
	m_RaidTypeC.AddString("RAID 2");
	m_RaidTypeC.AddString("RAID 3");
	m_RaidTypeC.AddString("RAID 4");
	m_RaidTypeC.AddString("RAID 5");
	m_RaidTypeC.AddString("RAID 0+1");
	m_RaidTypeC.AddString("RAID 1+5");

//  //

	m_UserName = AfxGetApp()->GetProfileString("Info","UserName");
	m_MachineName = AfxGetApp()->GetProfileString("Info","MachineName");
	m_Area = AfxGetApp()->GetProfileString("Info","Area");
	m_Mail = AfxGetApp()->GetProfileString("Info","Mail");
	m_Web = AfxGetApp()->GetProfileString("Info","Web");
	m_MotherBoardUser = AfxGetApp()->GetProfileString("Info","MotherBoard");
	m_MemoryUser = AfxGetApp()->GetProfileString("Info","Memory");
	m_Password = AfxGetApp()->GetProfileString("Info","Password");

	MEMORYSTATUS MemStatus;
	GlobalMemoryStatus(&MemStatus);
	m_MemorySizeUser.Format("%d",MemStatus.dwTotalPhys / 1024 / 1024 + 1);
	
	UpdateData(FALSE);

	return TRUE;
}

BOOL CRankingDlg::OnRankEntry() 
{
	UpdateData(TRUE);

/**/
	if(	m_UserName.IsEmpty()		|| m_CPUNameUser.IsEmpty() 
	||  m_MachineName.IsEmpty()		|| m_Area.IsEmpty()
	||	m_Password.IsEmpty()		|| m_ChipSetNameUser.IsEmpty()
	||	m_VideoNameUser.IsEmpty()	|| m_MemoryUser.IsEmpty()
	||	( m_RaidOn == 0 && m_DiskNameUser.IsEmpty() )
	||	( m_RaidOn == 1 && m_RaidController.IsEmpty() )
	)
	{
		if( gLanguage == JAPANESE ){
			MessageBox("K{͂Ă܂");
		}else{
			MessageBox("Please input essensial infomation.");
		}
		return FALSE;
	}

	if(! ( atof(m_ClockUser) > 0.0 && atof(m_ClockOriUser) > 0.0
		&& atof(m_SystemClockUser) > 0.0 && atof(m_SystemClockOriUser) > 0.0 
		&& atof(m_MultiplierUser) > 0.0 && atof(m_MultiplierOriUser) > 0.0 ) )
	{
		if( gLanguage == JAPANESE ){
			MessageBox("NbNg̏͐mɓ͂Ă");
		}else{
			MessageBox("Clock Infomation is unsuitable.");
		}
		return FALSE;
	}
	CString post;
	CString cstr;
///////////////////////
// User ͏
///////////////////////
	AddPostDataS(post,"UserName",m_UserName);
	AddPostDataS(post,"Machine",m_MachineName);
	AddPostDataS(post,"Area",m_Area);
	AddPostDataS(post,"Mail",m_Mail);
	AddPostDataS(post,"Web",m_Web);
	AddPostDataS(post,"Password",m_Password);
	AddPostDataS(post,"Comment",m_Comment);

	AddPostDataS(post,"CpuNameUser",m_CPUNameUser);
	AddPostDataS(post,"MotherUser",m_MotherBoardUser);
	AddPostDataS(post,"ChipSetUser",m_ChipSetNameUser);
	AddPostDataS(post,"VideoUser",m_VideoNameUser);
	AddPostDataI(post,"VideoSizeUser",m_VideoSizeUser);
	AddPostDataS(post,"MemoryUser",m_MemoryUser);
	AddPostDataI(post,"MemorySizeUser",m_MemorySizeUser);
	AddPostDataS(post,"DiskName",m_DiskNameUser);
	AddPostDataF(post,"DiskSize",m_DiskSizeUser);

	if(m_RaidOn){
		AddPostDataI(post,"RaidOn","1");
	}else{
		AddPostDataI(post,"RaidOn","0");
	}
	AddPostDataS(post,"RaidController",m_RaidController);
	AddPostDataS(post,"RaidType",m_RaidType);
	AddPostDataS(post,"RaidDisk1",m_RaidDisk1);
	AddPostDataS(post,"RaidDisk2",m_RaidDisk2);
	AddPostDataS(post,"RaidDisk3",m_RaidDisk3);
	AddPostDataS(post,"RaidDisk4",m_RaidDisk4);
	AddPostDataF(post,"RaidDisk1Size",m_RaidDisk1Size);
	AddPostDataF(post,"RaidDisk2Size",m_RaidDisk2Size);
	AddPostDataF(post,"RaidDisk3Size",m_RaidDisk3Size);
	AddPostDataF(post,"RaidDisk4Size",m_RaidDisk4Size);

	AddPostDataF(post,"ClockUser",m_ClockUser);
	AddPostDataF(post,"ClockOriUser",m_ClockOriUser);
	AddPostDataF(post,"SystemClockUser",m_SystemClockUser);
	AddPostDataF(post,"SystemClockOriUser",m_SystemClockOriUser);
	AddPostDataF(post,"MultiplierUser",m_MultiplierUser);
	AddPostDataF(post,"MultiplierOriUser",m_MultiplierOriUser);
	AddPostDataF(post,"OverClockUser",m_OverClockUser);

///////////////////////
// CPUDlg
///////////////////////

	AddPostDataS(post,"CpuName",Dlg->m_CPUDlg->m_CPUName);
	AddPostDataS(post,"CodeName",Dlg->m_CPUDlg->m_CodeName);
	AddPostDataS(post,"Platform",Dlg->m_CPUDlg->m_Platform);
	AddPostDataS(post,"CpuType",Dlg->m_CPUDlg->m_CPUType);

	AddPostDataF(post,"Clock",Dlg->m_CPUDlg->m_Clock);
	AddPostDataF(post,"ClockOri",Dlg->m_CPUDlg->m_ClockOri);
	AddPostDataF(post,"SystemClock",Dlg->m_CPUDlg->m_SystemClock);
	AddPostDataF(post,"SystemClockOri",Dlg->m_CPUDlg->m_SystemClockOri);
	AddPostDataF(post,"SystemBus",Dlg->m_CPUDlg->m_SystemBus);
	AddPostDataF(post,"SystemBusOri",Dlg->m_CPUDlg->m_SystemBusOri);
	AddPostDataF(post,"Multiplier",Dlg->m_CPUDlg->m_Multiplier);
	AddPostDataF(post,"MultiplierOri",Dlg->m_CPUDlg->m_MultiplierOri);
	AddPostDataF(post,"OverClock",Dlg->m_CPUDlg->m_OverClock);
	AddPostDataS(post,"DataRate",Dlg->m_CPUDlg->m_DataRate);
	
	AddPostDataS(post,"VendorString",Dlg->m_CPUDlg->m_VendorString);
	AddPostDataS(post,"NameString",Dlg->m_CPUDlg->m_NameString);

	AddPostDataX(post,"Apic",Dlg->m_CPUDlg->m_Apic);
	AddPostDataX(post,"BrandID",Dlg->m_CPUDlg->m_BrandID);
	AddPostDataX(post,"Family",Dlg->m_CPUDlg->m_Family);
	AddPostDataX(post,"ExFamily",Dlg->m_CPUDlg->m_ExFamily);
	AddPostDataX(post,"FamilyEx",Dlg->m_CPUDlg->m_FamilyEx);
	AddPostDataX(post,"Model",Dlg->m_CPUDlg->m_Model);
	AddPostDataX(post,"ExModel",Dlg->m_CPUDlg->m_ExModel);
	AddPostDataX(post,"Stepping",Dlg->m_CPUDlg->m_Stepping);
	AddPostDataX(post,"ExStepping",Dlg->m_CPUDlg->m_ExStepping);

	AddPostDataI(post,"CpuNumber",Dlg->m_CPUDlg->m_CPUNumber);
	AddPostDataI(post,"HyperThreadNum",Dlg->m_CPUDlg->m_HyperThreading);
	AddPostDataI(post,"L1I",Dlg->m_CPUDlg->m_L1ICache);
	AddPostDataI(post,"L1T",Dlg->m_CPUDlg->m_L1TCache);
	AddPostDataI(post,"L1U",Dlg->m_CPUDlg->m_L1UCache);

	AddPostDataI(post,"L1D",Dlg->m_CPUDlg->m_L1DataCache);
	AddPostDataI(post,"L2",Dlg->m_CPUDlg->m_L2Cache);
	AddPostDataI(post,"L3",Dlg->m_CPUDlg->m_L3Cache);
	AddPostDataF(post,"L2SpeedMHz",Dlg->m_CPUDlg->m_L2CacheSpeedMHz);
	AddPostDataS(post,"L2Speed",Dlg->m_CPUDlg->m_L2CacheSpeed);

///////////////////////
// SystemDlg
///////////////////////
	AddPostDataS(post,"OsName",Dlg->m_SystemDlg->m_SysOSCaption);
	// Ƃđ肽!!
	cstr = Dlg->m_SystemDlg->m_SysOSCSDVersion;
	cstr.Replace(" Service Pack ","");
	AddPostDataS(post,"OsServicePack",cstr);

	// OS ̏ڍ׏ //
	OSVERSIONINFOEX osvi;
	BOOL bOsVersionInfoEx;

	ZeroMemory(&osvi, sizeof(OSVERSIONINFOEX));
	osvi.dwOSVersionInfoSize = sizeof(OSVERSIONINFOEX);
	if( !(bOsVersionInfoEx = GetVersionEx ((OSVERSIONINFO *) &osvi)) )
	{
		osvi.dwOSVersionInfoSize = sizeof (OSVERSIONINFO);
		GetVersionEx( (OSVERSIONINFO *) &osvi);
	}

	AddPostDataI(post,"OsVersionMajor",osvi.dwMajorVersion);
	AddPostDataI(post,"OsVersionMinor",osvi.dwMinorVersion);
	AddPostDataI(post,"OsVersionBuild",osvi.dwBuildNumber);
	AddPostDataI(post,"OsType",osvi.dwPlatformId);

	AddPostDataS(post,"BiosVendor",Dlg->m_SystemDlg->m_SysBiosManufacturer);
	AddPostDataS(post,"BiosCaption",Dlg->m_SystemDlg->m_SysBiosCaption);
	AddPostDataS(post,"BiosVersion",Dlg->m_SystemDlg->m_SysBiosVersion);
	AddPostDataS(post,"BiosDate",Dlg->m_SystemDlg->m_SysBiosDate);
	AddPostDataS(post,"SmBiosCaption",Dlg->m_SystemDlg->m_SysBiosSMBiosVersion);
	AddPostDataS(post,"SmBiosVersion",Dlg->m_SystemDlg->m_SysBiosSMVersion);
	AddPostDataS(post,"SystemVendor",Dlg->m_SystemDlg->m_SysSystemManufacturer);
	AddPostDataS(post,"SystemModel",Dlg->m_SystemDlg->m_SysSystemModel);
	AddPostDataS(post,"MotherVendor",Dlg->m_SystemDlg->m_SysMotherManufacturer);
	AddPostDataS(post,"MotherProduct",Dlg->m_SystemDlg->m_SysMotherProduct);
	AddPostDataS(post,"MotherVersion",Dlg->m_SystemDlg->m_SysMotherVersion);

///////////////////////
// DeviceDlg
///////////////////////
	AddPostDataS(post,"ChipSet",Dlg->m_DeviceDlg->m_DeviceChipSet);
	AddPostDataS(post,"North",Dlg->m_DeviceDlg->m_DeviceNorth);
	AddPostDataS(post,"South",Dlg->m_DeviceDlg->m_DeviceSouth);
	AddPostDataS(post,"IdeController",Dlg->m_DeviceDlg->m_DeviceIDE);

	AddPostDataS(post,"Video",Dlg->m_DeviceDlg->m_DeviceVideo);
//	AddPostDataS(post,"DisplayMode",Dlg->m_DeviceDlg->m_DeviceDisplayMode);
//	AddPostDataS(post,"FontSmoothing",Dlg->m_DeviceDlg->m_DeviceFontSmoothing);
	AddPostDataS(post,"DirectX",Dlg->m_DeviceDlg->m_DeviceDirectXVersion);
	AddPostDataS(post,"VideoProduct",Dlg->m_DeviceDlg->m_DeviceVideoCaption);
	AddPostDataS(post,"VideoVendor",Dlg->m_DeviceDlg->m_DeviceVideoVendor);
	AddPostDataS(post,"VideoChip",Dlg->m_DeviceDlg->m_DeviceVideoChip);
	AddPostDataI(post,"VideoRam",Dlg->m_DeviceDlg->m_DeviceVideoRAM);
	AddPostDataS(post,"VideoDriverVersion",Dlg->m_DeviceDlg->m_DeviceVideoDriverVersion);
	AddPostDataS(post,"VideoDriverDate",Dlg->m_DeviceDlg->m_DeviceVideoDriverDate);

// ID
	AddPostDataI(post,"NorthVID",Dlg->m_DeviceDlg->m_DeviceNorthVID);
	AddPostDataI(post,"SouthVID",Dlg->m_DeviceDlg->m_DeviceSouthVID);
	AddPostDataI(post,"VideoVID",Dlg->m_DeviceDlg->m_DeviceVideoVID);
	AddPostDataI(post,"NorthDID",Dlg->m_DeviceDlg->m_DeviceNorthDID);
	AddPostDataI(post,"SouthDID",Dlg->m_DeviceDlg->m_DeviceSouthDID);
	AddPostDataI(post,"VideoDID",Dlg->m_DeviceDlg->m_DeviceVideoDID);
	AddPostDataI(post,"NorthRID",Dlg->m_DeviceDlg->m_DeviceNorthRID);
	AddPostDataI(post,"SouthRID",Dlg->m_DeviceDlg->m_DeviceSouthRID);
	AddPostDataI(post,"VideoRID",Dlg->m_DeviceDlg->m_DeviceVideoRID);

///////////////////////
// BenchMark Setting
///////////////////////
//	Dlg->m_MarkDlg->m_MarkOptionProcessorMask.GetWindowText(cstr);
//	Dlg->m_MarkDlg->m_MarkOptionHDDSize.GetWindowText(cstr);

	AddPostDataS(post,"ProcessorMask",Dlg->m_MarkDlg->BenchSetting.ProcessorMask);
	AddPostDataI(post,"BenchDiskSize",Dlg->m_MarkDlg->BenchSetting.DiskSize);

	AddPostDataS(post,"DisplayMode",Dlg->m_MarkDlg->BenchSetting.DisplayMode);
	AddPostDataS(post,"FontSmoothing",Dlg->m_MarkDlg->BenchSetting.FontSmoothing);

	AddPostDataI(post,"DISP1",Dlg->m_MarkDlg->BenchSetting.DISP1);
	AddPostDataI(post,"DISP2",Dlg->m_MarkDlg->BenchSetting.DISP2);
	AddPostDataI(post,"DISP3",Dlg->m_MarkDlg->BenchSetting.DISP3);
	AddPostDataI(post,"DISP4",Dlg->m_MarkDlg->BenchSetting.DISP4);

///////////////////////
// BenchMark Score
///////////////////////
	char table[10][4] = {"ALU","FPU","MEM","HDD","MMT","GDI","D2D","D3D","OGL","NET"};

	int i,j;
	CString score;

	// Mark ͓
	score.Format("%d",Dlg->m_MarkDlg->R[0][0]);
	AddPostDataI(post,"Mark",score);

	for(j=0;j<10;j++){
		cstr.Format("T%s",table[j]);
		score.Format("%d",Dlg->m_MarkDlg->R[0][j+1]);
		AddPostDataI(post,cstr,score);
	}

	for(i=0;i<10;i++){
		for(j=0;j<8;j++){
			cstr.Format("%s%d",table[i],j+1);
			score.Format("%d",Dlg->m_MarkDlg->R[i+1][j]);
			AddPostDataI(post,cstr,score);
			cstr.Format("%s%dV",table[i],j+1);
			score.Format("%d",Dlg->m_MarkDlg->V[i+1][j]);
			AddPostDataI(post,cstr,score);
		}
	}
///////////////////////
// TEXT COPY
///////////////////////
//	Dlg->Copy("standard.txt",0,3,&cstr);
//	AddPostDataS(post,"TextCopy",cstr);

///////////////////////
// Version 
///////////////////////

	char *token;
	char buf[32];
	CString ver = Dlg->CrystalMarkVersion;
	ver.Replace("CrystalMark ","");
	ver.Replace(" Beta","");
	strcpy(buf,ver);
	token = strtok( buf , "." );cstr.Format("Major=%s",token);post += ( cstr + "&" );
	token = strtok( NULL, "." );cstr.Format("Minor=%s",token);post += ( cstr + "&" );
	token = strtok( NULL, "." );cstr.Format("Revision=%s",token);post += ( cstr + "&" );
	token = strtok( NULL, "." );cstr.Format("Release=%s",token);post += ( cstr + "&" );

	post += "check=1";

	int result = 0;
	result = HttpPostMethod((LPSTR)(LPCTSTR)post,SERVER_NAME,SCRIPT_PATH,USER_AGENT);

	if(result > 0){
		cstr.Format(RANKING_STR,result);
		ShellExecute(m_hWnd,"open",cstr,NULL,NULL,SW_SHOWNORMAL);
	}else if(result == ERROR_HTTP_OFF_LINE || result == 0 ){
		if( gLanguage == JAPANESE ){
			if(MessageBox(
				"Web œo^s߂ɕKvȃf[^Nbv{[hɃRs[܂H",
				NULL,MB_YESNO) == IDYES)
			{
				CString clip = post;
				if(OpenClipboard())
				{
					HGLOBAL clipbuffer;
					char * buffer;
					EmptyClipboard();
					clipbuffer = GlobalAlloc(GMEM_DDESHARE, clip.GetLength()+1);
					buffer = (char*)GlobalLock(clipbuffer);
					strcpy(buffer, LPCSTR(clip));
					GlobalUnlock(clipbuffer);
					SetClipboardData(CF_TEXT,clipbuffer);
					CloseClipboard();
				}
			}
		}else{
			MessageBox("HTTP Server is down now.");
		}
	}else if(result == ERROR_HTTP_SAME_DATA){
		if( gLanguage == JAPANESE ){
			MessageBox("dê悤łB");
		}else{
			MessageBox("Already registed.");
		}
	}else if(result == ERROR_HTTP_SAME_MACHINE){
		if( gLanguage == JAPANESE ){
			MessageBox("}Vŕo^ꍇ͕KRgɉǂႤ̂LĂB");
		}else{
			MessageBox("Already registed.");
		}
	}
	
	return TRUE;
}


void CRankingDlg::OnOK() {}
void CRankingDlg::OnCancel() {}

HBRUSH CRankingDlg::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
	HBRUSH hbr = CDialog::OnCtlColor(pDC, pWnd, nCtlColor);

	if( gFlagBack ){
		switch (nCtlColor)
		{
			case CTLCOLOR_STATIC:
			{
				pDC->SetTextColor(gTextColor);
				pDC->SetBkMode(TRANSPARENT);
				return (HBRUSH)GetStockObject(HOLLOW_BRUSH);
			}
			case CTLCOLOR_DLG:
			{
				return (HBRUSH)gBackBrush;
			}
		}
	}else{
		switch (nCtlColor)
		{
			case CTLCOLOR_STATIC:
			{
				pDC->SetTextColor(gTextColor);
				pDC->SetBkMode(TRANSPARENT);
			}
		}
	}

	return hbr;

	return hbr;
}

void CRankingDlg::OnShowWindow(BOOL bShow, UINT nStatus) 
{
	CDialog::OnShowWindow(bShow, nStatus);

// Entry {^
#ifdef _DEBUG
	m_EntryC.EnableWindow(TRUE);
#else if
	m_EntryC.EnableWindow(Dlg->m_MarkDlg->IsEntryOK());
#endif
	m_RankResultList.DeleteAllItems();
	
	char str[256];
	CString cstr;
	LVITEM myItem;
	memset(&myItem,0,sizeof(LVITEM));
	myItem.mask = LVIF_TEXT;
	int count=0;
	for(int Number=0;Number<=10;Number++){
		GetBenchString(0,Number,str);
		if( strcmp(str,"") != 0){
			myItem.iItem = count;
			myItem.iSubItem = 0;		
			myItem.pszText = str;
			m_RankResultList.InsertItem(&myItem);
			cstr.Format("%d",Dlg->m_MarkDlg->R[0][Number]);
			m_RankResultList.SetItemText(count,1,cstr);
			count++;
		}
	}	
}

void CRankingDlg::OnRankResultDialog() 
{
	CResultDlg ResultDlg(Dlg);
	ResultDlg.DoModal();	
}

BOOL CRankingDlg::DestroyWindow() 
{
	return CDialog::DestroyWindow();
}

void CRankingDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	UpdateData(TRUE);
	AfxGetApp()->WriteProfileString("Info","UserName",m_UserName);
	AfxGetApp()->WriteProfileString("Info","MachineName",m_MachineName);
	AfxGetApp()->WriteProfileString("Info","Area",m_Area);
	AfxGetApp()->WriteProfileString("Info","Mail",m_Mail);
	AfxGetApp()->WriteProfileString("Info","Web",m_Web);
	AfxGetApp()->WriteProfileString("Info","MotherBoard",m_MotherBoardUser);
	AfxGetApp()->WriteProfileString("Info","Memory",m_MemoryUser);
	AfxGetApp()->WriteProfileString("Info","Password",m_Password);	
}
#endif // #ifndef CRYSTAL_SYS_INFO

